package exam8;

import com.google.common.collect.ImmutableList;

import java.util.HashMap;
import java.util.Map;

interface Expression {
    double getValue(EvaluationContext context);

    Expression copy();

    Expression derivative(String variable);

// ODKOMENTUJTE a doplnte kod
//    Iterator<String> variableIterator();
}

class EvaluationContext {
    final private Map<String, Double> memory = new HashMap<>();

    void setVariable(String name, double val) {
        memory.put(name, val);
    }

    double getVariable(String name) {
        if (memory.containsKey(name)) {
            return memory.get(name);
        } else {
            throw new IllegalStateException("Variable \"" + name + "\" not set !");
        }
    }
}

abstract class AbstractExpression implements Expression {
    // Pokud se vam tato trida nebude hodit, odstrante ji.
}

abstract class CompoundExpression extends AbstractExpression {
    final protected ImmutableList<Expression> args;

    protected CompoundExpression(ImmutableList<Expression> args) {
        this.args = args;
    }

    Expression getArg(int index) {
        return args.get(index);
    }
}

class Constant extends AbstractExpression {
    final private double value;

    Constant(double value) {
        this.value = value;
    }

    @Override
    public double getValue(EvaluationContext context) {
        throw new IllegalStateException("Doplnte kod!");
    }

    @Override
    public Expression copy() {
        throw new IllegalStateException("Doplnte kod!");
    }

    @Override
    public Expression derivative(String variable) {
        throw new IllegalStateException("Doplnte kod!");
    }
}

class Variable extends AbstractExpression {
    final private String name;

    Variable(String name) {
        this.name = name;
    }

    String getName() {
        return name;
    }

    @Override
    public double getValue(EvaluationContext context) {
        throw new IllegalStateException("Doplnte kod!");
    }

    @Override
    public Expression copy() {
        throw new IllegalStateException("Doplnte kod!");
    }

    @Override
    public Expression derivative(String variable) {
        throw new IllegalStateException("Doplnte kod!");
    }
}

class Sin extends CompoundExpression {
    Sin(Expression arg) {
        super(ImmutableList.<Expression>of(arg));
    }

    @Override
    public double getValue(EvaluationContext context) {
        throw new IllegalStateException("Doplnte kod!");
    }

    @Override
    public Expression copy() {
        throw new IllegalStateException("Doplnte kod!");
    }

    @Override
    public Expression derivative(String variable) {
        throw new IllegalStateException("Doplnte kod!");
    }
}

class Cos extends CompoundExpression {
    Cos(Expression arg) {
        super(ImmutableList.<Expression>of(arg));
    }

    @Override
    public double getValue(EvaluationContext context) {
        throw new IllegalStateException("Doplnte kod!");
    }

    @Override
    public Expression copy() {
        throw new IllegalStateException("Doplnte kod!");
    }

    @Override
    public Expression derivative(String variable) {
        throw new IllegalStateException("Doplnte kod!");
    }
}

class Power extends CompoundExpression {

    Power(Expression base, Expression exp) {
        super(ImmutableList.<Expression>of(base, exp));
    }

    @Override
    public double getValue(EvaluationContext context) {
        throw new IllegalStateException("Doplnte kod!");
    }

    @Override
    public Expression copy() {
        throw new IllegalStateException("Doplnte kod!");
    }

    @Override
    public Expression derivative(String variable) {
        throw new IllegalStateException("Doplnte kod!");
    }
}

class Add extends CompoundExpression {
    Add(ImmutableList<Expression> args) {
        super(args);
    }

    Add(Expression left, Expression right) {
        this(ImmutableList.<Expression>of(left, right));
    }

    @Override
    public double getValue(EvaluationContext context) {
        throw new IllegalStateException("Doplnte kod!");
    }

    @Override
    public Expression copy() {
        throw new IllegalStateException("Doplnte kod!");
    }

    @Override
    public Expression derivative(String variable) {
        throw new IllegalStateException("Doplnte kod!");
    }
}

class Multiply extends CompoundExpression {

    Multiply(ImmutableList<Expression> args) {
        super(args);
    }

    Multiply(Expression left, Expression right) {
        this(ImmutableList.<Expression>of(left, right));
    }

    @Override
    public double getValue(EvaluationContext context) {
        throw new IllegalStateException("Doplnte kod!");
    }

    @Override
    public Expression copy() {
        throw new IllegalStateException("Doplnte kod!");
    }

    @Override
    public Expression derivative(String variable) {
        throw new IllegalStateException("Doplnte kod!");
    }
}

interface ExpressionVisitor {
    void visitConstant(Constant c);

    void visitVariable(Variable v);

    void visitSin(Sin v);

    void visitCos(Cos v);

    void visitPower(Power v);

    void visitAdd(Add v);

    void visitMultiply(Multiply v);
}

// ODKOMENTUJTE a doplnte kod
//class PrintExpressionVisitor implements ExpressionVisitor {
//}

// ODKOMENTUJTE a doplnte kod
//class SimplifyExpressionVisitor implements ExpressionVisitor {
//}

public class code {
    public static void main(String[] args) {
        // Zde testujte funkcnost kodu.
    }
}
